function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Encapsulates all logging behaviour and provides the ability to specify the level
 * of logging desired.
 * @class
 */
var Logger =
/*#__PURE__*/
function () {
  _createClass(Logger, [{
    key: "noop",

    /**
     * Icons prefixed to the start of logging statements that cycled through each
     * time a focus tree changes, making it easier to quickly spot events related
     * to the same focus tree.
     */

    /**
     * Icons prefixed to the start of logging statements that cycled through each
     * time a component ID changes, making it easier to quickly spot events related
     * to the same component.
     */

    /**
     * Icons prefixed to the start of logging statements that cycled through each
     * time an event ID changes, making it easier to quickly trace the path of KeyEvent
     * objects as they propagate through multiple components.
     */

    /**
     * The level of logging to perform
     * @typedef {'none'|'error'|'warn'|'info'|'debug'|'verbose'} LogLevel
     */

    /**
     * Levels of log severity - the higher the log level, the greater the amount (and
     * lesser the importance) of information logged to the console about React HotKey's
     * behaviour
     * @enum {number} LogLevel
     */
    value: function noop() {}
    /**
     * By default, calls to all log severities are a no-operation. It's only when the
     * user specifies a log level, are they replaced with logging statements
     * @type {Logger.noop}
     */

  }]);

  function Logger() {
    var _this = this;

    var logLevel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'warn';

    _classCallCheck(this, Logger);

    _defineProperty(this, "verbose", this.noop);

    _defineProperty(this, "debug", this.noop);

    _defineProperty(this, "info", this.noop);

    _defineProperty(this, "warn", this.noop);

    _defineProperty(this, "error", this.noop);

    this.logLevel = this.constructor.levels[logLevel];
    var _arr = ['error', 'warn', 'info', 'debug', 'verbose'];

    var _loop = function _loop() {
      var level = _arr[_i];

      if (_this.logLevel < _this.constructor.levels[level]) {
        return {
          v: void 0
        };
      }

      var logToConsole = ['debug', 'verbose'].indexOf(level) === -1 ? console[level] : console.log;

      _this[level] = function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var materializedArgs = args.map(function (arg) {
          return (// Function arguments are evaluated lazily to reduce performance overhead
            typeof arg === 'function' ? arg() : arg
          );
        });
        logToConsole.apply(void 0, _toConsumableArray(materializedArgs));
      };
    };

    for (var _i = 0; _i < _arr.length; _i++) {
      var _ret = _loop();

      if (_typeof(_ret) === "object") return _ret.v;
    }
  }

  return Logger;
}();

_defineProperty(Logger, "logIcons", ['📕', '📗', '📘', '📙']);

_defineProperty(Logger, "componentIcons", ['🔺', '⭐️', '🔷', '🔶', '⬛️']);

_defineProperty(Logger, "eventIcons", ['❤️', '💚', '💙', '💛', '💜', '🧡']);

_defineProperty(Logger, "levels", {
  none: 0,
  error: 1,
  warn: 2,
  info: 3,
  debug: 4,
  verbose: 5
});

export default Logger;